﻿using System;

namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Поток FORTS_FUTINFO_REPL - Фьючерсы: справочная и сессионная информация.
	/// Таблица fut_bond_nominal: Размеры выплат номинальной стоимости облигации.
	/// </summary>
	public class PlazaBondNominalFutureColumns : PlazaColumns
	{
		internal PlazaBondNominalFutureColumns()
			: base(PlazaTableId.BondNominalFuture)
		{
			BondId = new PlazaColumn(TableId, "bond_id", typeof(int));
			Date = new PlazaColumn(TableId, "date", typeof(DateTime));
			Nominal = new PlazaColumn(TableId, "nominal", "d16.5");
		}

		/// <summary>
		/// Цифровой код облигации.
		/// </summary>
		public readonly PlazaColumn BondId;

		/// <summary>
		/// Дата выплаты купона.
		/// </summary>
		public readonly PlazaColumn Date;

		/// <summary>
		/// Размер выплат номинальной стоимости.
		/// </summary>
		public readonly PlazaColumn Nominal;
	}
}