﻿namespace StockSharp.Plaza.Metadata
{
    /// <summary>
    /// Поток FORTS_INFO_REPL - Дополнительная справочная информация.
    /// Таблица broker_params - Информация о параметрах фирм.
    /// </summary>
    public class PlazaBrokerParamsColumns : PlazaColumns
    {
        internal PlazaBrokerParamsColumns()
            : base(PlazaTableId.BrokerParams)
        {
            BrokerCode = new PlazaColumn(TableId, "broker_code", "c7");            
            CodeVCB = new PlazaColumn(TableId, "code_vcb", "c25");
            LimitSpotSell = new PlazaColumn(TableId, "limit_spot_sell", typeof(int));
            UsedLimitSpotSell = new PlazaColumn(TableId, "used_limit_spot_sell", typeof(int));
        }

        /// <summary>
        /// Код брокерской фирмы.
        /// </summary>
        public readonly PlazaColumn BrokerCode;
        
        /// <summary>
        /// Код базового контракта.
        /// </summary>
        public readonly PlazaColumn CodeVCB;

        /// <summary>
        /// Лимит на открытие позиций в продажу на RTS Standard по данной акции (базовому контракту).
        /// </summary>
        public readonly PlazaColumn LimitSpotSell;

        /// <summary>
        /// Использованный лимит на открытие позиций в продажу на RTS Standard по данной акции.
        /// </summary>
        public readonly PlazaColumn UsedLimitSpotSell;

    }
}