﻿namespace StockSharp.Plaza.Metadata
{
	using System;

	/// <summary>
	/// Базовый класс, содержащий 3 специальные Plaza колонки: replID, replRev, replAct.
	/// </summary>
	public abstract class PlazaColumns
	{
		internal PlazaColumns(PlazaTableId tableId)
		{
			if (tableId == null)
				throw new ArgumentNullException("tableId");

			TableId = tableId;
			ReplId = new PlazaColumn(tableId, "replID", typeof(long));
			ReplRev = new PlazaColumn(tableId, "replRev", typeof(long));
			ReplAct = new PlazaColumn(tableId, "replAct", typeof(long));
		}

		internal PlazaTableId TableId { get; private set; }

		/// <summary>
		/// Служебное поле подсистемы репликации.
		/// </summary>
		public readonly PlazaColumn ReplId;

		/// <summary>
		/// Служебное поле подсистемы репликации.
		/// </summary>
		public readonly PlazaColumn ReplRev;

		/// <summary>
		/// Служебное поле подсистемы репликации.
		/// </summary>
		public readonly PlazaColumn ReplAct;
	}
}