﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Колонки таблицы, содержащей справочник базовых контрактов для инструментов.
	/// Поток FORTS_FUTCOMMON_REPL - таблица common.
	/// </summary>
	public class PlazaCommonFutureColumns : PlazaCommonDerivativeColumns
	{
		internal PlazaCommonFutureColumns()
			: base(PlazaTableId.CommonFuture)
		{
			CurrentQuote = new PlazaColumn(TableId, "cur_kotir", "d16.5", false);
			CurrentMarketQuote = new PlazaColumn(TableId, "cur_kotir_real", "d16.5", false);
		}

		/// <summary>
		/// Текущая котировка.
		/// </summary>
		public readonly PlazaColumn CurrentQuote;

		/// <summary>
		/// Рыночная котировка.
		/// </summary>
		public readonly PlazaColumn CurrentMarketQuote;
	}
}