﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Колонки таблицы, содержащей справочник базовых контрактов для инструментов.
	/// Поток FORTS_OPTCOMMON_REPL - таблица common.
	/// </summary>
	public class PlazaCommonOptionColumns : PlazaCommonDerivativeColumns
	{
		internal PlazaCommonOptionColumns()
			: base(PlazaTableId.CommonOption)
		{
			IsinIsSpec = new PlazaColumn(TableId, "isin_is_spec", typeof(bool), false);
		}

		/// <summary>
		/// По этому инструменту сейчас возможно подавать запросы на котировку.
		/// </summary>
		public readonly PlazaColumn IsinIsSpec;
	}
}