﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// FORTS_FUTINFO_REPL - Фьючерсы: справочная и сессионная информация.
	/// Таблица multileg_dict: Справочник связок.
	/// </summary>
	public class PlazaMultiLegFutureColumns : PlazaColumns
	{
		internal PlazaMultiLegFutureColumns()
			: base(PlazaTableId.MultiLegDealFuture)
		{
			SessionId = new PlazaColumn(TableId, "sess_id", typeof(int));
			IsinId = new PlazaColumn(TableId, "isin_id", typeof(int));
			IsinIdLeg = new PlazaColumn(TableId, "isin_id_leg", typeof(int));
			QtyRatio = new PlazaColumn(TableId, "qty_ratio", typeof(int));
		}

		/// <summary>
		/// Идентификатор торговой сессии.
		/// </summary>
		public readonly PlazaColumn SessionId;

		/// <summary>
		/// Уникальный числовой код связки.
		/// </summary>
		public readonly PlazaColumn IsinId;

		/// <summary>
		/// Уникальный код инструмента, входящего в связку.
		/// </summary>
		public readonly PlazaColumn IsinIdLeg;

		/// <summary>
		/// Коэффициент количества.
		/// </summary>
		public readonly PlazaColumn QtyRatio;
	}
}