﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Колонки таблицы, содержащей результаты клиринга: волатильность и теоретические цены.
    /// Поток FORTS_CLR_REPL - таблица opt_sess_settl.
	/// </summary>
	public class PlazaSessionSettlementOptionColumns : PlazaSessionSettlementDerivativeColumns
	{
		internal PlazaSessionSettlementOptionColumns()
			: base(PlazaTableId.SessionSettlementOption)
		{
            Volatility = new PlazaColumn(TableId, "volat", "d16.5");
			TheoreticalPrice = new PlazaColumn(TableId, "theor_price", "d16.5");
		}
        
		/// <summary>
		/// Волатильность опциона.
		/// </summary>
		public readonly PlazaColumn Volatility;

		/// <summary>
		/// Теоретическая цена опциона.
		/// </summary>
		public readonly PlazaColumn TheoreticalPrice;
	}
}