﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Колонки таблицы, содержащей справочник базовых контрактов для фьючерсов.
	/// Поток FORTS_FUTINFO_REPL - таблица fut_vcb.
	/// </summary>
	public class PlazaVcbFutureColumns : PlazaVcbDerivativeColumns
	{
		internal PlazaVcbFutureColumns()
			: base(PlazaTableId.VcbFuture)
		{
			Section = new PlazaColumn(TableId, "section", "c50");
			ExchPaySpot = new PlazaColumn(TableId, "exch_pay_spot", "d16.5");
		}

		/// <summary>
		/// Наименование Секции.
		/// </summary>
		public readonly PlazaColumn Section;

		/// <summary>
		/// Биржевой сбор по Спотам за 1 лот в % от цены.
		/// </summary>
		public readonly PlazaColumn ExchPaySpot;
	}
}