﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Поток FORTS_OPTINFO_REPL - Опционы: справочная и сессионная информация.
	/// Таблица opt_vcb: Справочник торгуемых активов опционов.
	/// </summary>
	public class PlazaVcbOptionColumns : PlazaVcbDerivativeColumns
	{
		internal PlazaVcbOptionColumns()
			: base(PlazaTableId.VcbOption)
		{
			CoeffOut = new PlazaColumn(TableId, "coeff_out", "d7.3");
			IsSpec = new PlazaColumn(TableId, "is_spec", typeof(bool));
			SpecSpread = new PlazaColumn(TableId, "spec_spread", "d16.5");
			MinVol = new PlazaColumn(TableId, "min_vol", typeof(int));
		}

		/// <summary>
		/// Коэффициент приближенности 'внелимитных' опционов.
		/// </summary>
		public readonly PlazaColumn CoeffOut;

		/// <summary>
		/// 1 - по этому контракту шлюз (и его фирма) является специалистом по запросам на котировку.
		/// </summary>
		public readonly PlazaColumn IsSpec;

		/// <summary>
		/// Спред специалиста.
		/// </summary>
		public readonly PlazaColumn SpecSpread;

		/// <summary>
		/// Минимальный объем в котировках специалиста.
		/// </summary>
		public readonly PlazaColumn MinVol;
	}
}