﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Поток FORTS_VM_REPL - Вариационная маржа.
	/// Таблица fut_vm - Вариационная маржа по фьючерсам.
	/// </summary>
	public class PlazaVmFutureColumns : PlazaVmDerivativeColumns
	{
		internal PlazaVmFutureColumns()
			: base(PlazaTableId.VmFuture)
		{
			VmReal = new PlazaColumn(TableId, "vm_real", "d16.5");
		}

		/// <summary>
		/// Накопленная по сделкам вариационная маржа по фьючерсам, рассчитанная по текущей рыночной котировке.
		/// </summary>
		public readonly PlazaColumn VmReal;
	}
}