﻿namespace StockSharp.Plaza.Metadata
{
	/// <summary>
	/// Поток FORTS_VOLAT_REPL - Волатильность.
	/// Таблица volat - Волатильность.
	/// </summary>
	public class PlazaVolatilityColumns : PlazaColumns
	{
		internal PlazaVolatilityColumns()
			: base(PlazaTableId.Volatility)
		{
			IsinId = new PlazaColumn(TableId, "isin_id", typeof(int));
			SessionId = new PlazaColumn(TableId, "sess_id", typeof(int));
			Volatility = new PlazaColumn(TableId, "volat", "d16.5");
            TheorPrice = new PlazaColumn(TableId, "theor_price", "d16.5");
		}

		/// <summary>
		/// Уникальный числовой идентификатор инструмента.
		/// </summary>
		public readonly PlazaColumn IsinId;

		/// <summary>
		/// Идентификатор торговой сессии.
		/// </summary>
		public readonly PlazaColumn SessionId;

		/// <summary>
		/// Волатильность опциона.
		/// </summary>
		public readonly PlazaColumn Volatility;

		/// <summary>
		/// Теоретическая цена опциона.
		/// </summary>
		public readonly PlazaColumn TheorPrice;
	}
}