﻿namespace StockSharp.Plaza
{
	using System.Net;

	using Ecng.Common;

	/// <summary>
	/// Адреса серверов системы Plaza.
	/// </summary>
	public static class PlazaAddresses
	{
		/// <summary>
		/// Порт по умолчанию для рабочих подключений к Plaza.
		/// </summary>
		public const int DefaultPlaza2Port = 4001;

		/// <summary>
		/// Порт по умолчанию для тестовых подключений к Plaza.
		/// </summary>
		public const int DefaultPlaza2TestPort = 3001;

		/// <summary>
		/// Адрес боевого сервера. 194.247.133.20.
		/// </summary>
		public static readonly IPAddress Battle = "194.247.133.20".To<IPAddress>();

		/// <summary>
		/// Адрес демо сервера. 194.247.133.43.
		/// </summary>
		public static readonly IPAddress Test = "194.247.133.43".To<IPAddress>();
	}
}