﻿namespace StockSharp.Plaza
{
	using System;
	using System.Collections.Generic;
	using System.Linq;
	using System.Reflection;

	using Ecng.Collections;
	using Ecng.Reflection;

	using StockSharp.Plaza.Metadata;

	/// <summary>
	/// Реестр всех потоков данных сервера Плазы.
	/// </summary>
	public class PlazaStreamRegistry
	{
		internal PlazaStreamRegistry()
		{
			var streams = new List<PlazaStream>();

			streams.Add(Aggregation20FutureStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation20Future, "Фьючерсы: стакан глубиной 20 котировок"), SecurityGrops.Future));
			streams.Add(Aggregation20OptionStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation20Option, "Опционы: стакан глубиной 20 котировок"), SecurityGrops.Option));
			streams.Add(Aggregation50FutureStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation50Future, "Фьючерсы: стакан глубиной 50 котировок"), SecurityGrops.Future));
			streams.Add(Aggregation50OptionStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation50Option, "Опционы: стакан глубиной 50 котировок"), SecurityGrops.Option));
			streams.Add(Aggregation5FutureStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation5Future, "Фьючерсы: стакан глубиной 5 котировок"), SecurityGrops.Future));
			streams.Add(Aggregation5OptionStream = new PlazaStream(new PlazaTable(PlazaTableId.Aggregation5Option, "Опционы: стакан глубиной 5 котировок"), SecurityGrops.Option));
			streams.Add(BondIsinFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.BondIsinFuture, "Фьючерсы: справочник инструментов облигаций"), SecurityGrops.Future));
			streams.Add(BondNkdFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.BondNkdFuture, "Фьючерсы: НКД на даты выплат купонов"), SecurityGrops.Future));
			streams.Add(BondNominalFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.BondNominalFuture, "Фьючерсы: размеры выплат номинальной стоимости облигации"), SecurityGrops.Future));
			streams.Add(BondRegistryFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.BondRegistryFuture, "Фьючерсы: справочник параметров облигаций"), SecurityGrops.Future));
			streams.Add(CommonFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.CommonFuture, "Фьючерсы: общая информация по сессии"), SecurityGrops.Future));
			streams.Add(CommonOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.CommonOption, "Опционы: общая информация по сессии"), SecurityGrops.Option));
			streams.Add(DealFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.DealFuture, "Фьючерсы: журнал сделок"), SecurityGrops.Future));
			streams.Add(DealOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.DealOption, "Опционы: журнал сделок"), SecurityGrops.Option));
			streams.Add(DeliveryReportFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.DeliveryReportFuture, "Фьючерсы: отчет о поставке"), SecurityGrops.Future));
			streams.Add(ExpirationOrdersOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.ExpirationOrdersOption, "Опционы: заявки на экспирацию"), SecurityGrops.Option));
			streams.Add(HeartBeatFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.HeartBeatFuture, "Фьючерсы: служебная таблица серверных часов"), SecurityGrops.Future));
			streams.Add(HeartBeatOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.HeartBeatOption, "Опционы: служебная таблица серверных часов"), SecurityGrops.Option));
			streams.Add(InterClearingInfoFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.InterClearingInfoFuture, "Фьючерсы: информация о ВМ, рассчитанной по результатам пром. клиринга"), SecurityGrops.Future));
			streams.Add(InterClearingInfoOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.InterClearingInfoOption, "Опционы: информация о ВМ, рассчитанной по результатам пром. клиринга"), SecurityGrops.Option));
			streams.Add(MultiLegDealFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.MultiLegDealFuture, "Фьючерсы: журнал сделок по связкам"), SecurityGrops.Future));
			streams.Add(MultiLegOrdersLogFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.MultiLegOrdersLogFuture, "Фьючерсы: журнал заявок по связкам"), SecurityGrops.Future));
			streams.Add(OrderBookInfoFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.OrderBookInfoFuture, "Фьючерсы: срез стакана (информация о стаканах)"), SecurityGrops.Future));
			streams.Add(OrderBookInfoOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.OrderBookInfoOption, "Опционы: срез стакана (информация о стаканах)"), SecurityGrops.Option));
			streams.Add(OrderBookOrdersFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.OrderBookOrdersFuture, "Фьючерсы: срез стакана (логовая таблица заявок)"), SecurityGrops.Future));
			streams.Add(OrderBookOrdersOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.OrderBookOrdersOption, "Опционы: срез стакана (логовая таблица заявок)"), SecurityGrops.Option));
			streams.Add(OrdersLogFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.OrdersLogFuture, "Фьючерсы: журнал заявок"), SecurityGrops.Future));
			streams.Add(OrdersLogOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.OrdersLogOption, "Опционы: журнал заявок"), SecurityGrops.Option));
			streams.Add(PortfoliosStream = new PlazaStream(new PlazaTable(PlazaTableId.Portfolios, "Средства и лимиты клиентов")));
			streams.Add(PositionsStream = new PlazaStream(new PlazaTable(PlazaTableId.Positions, "Позиции клиентов")));
			streams.Add(RejectedOrdersFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.RejectedOrdersFuture, "Фьючерсы: отвергнутые в клиринг заявки"), SecurityGrops.Future));
			streams.Add(RejectedOrdersOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.RejectedOrdersOption, "Опционы: отвергнутые в клиринг заявки"), SecurityGrops.Option));
			streams.Add(RtsIndexStream = new PlazaStream(new PlazaTable(PlazaTableId.RtsIndex, "Индексы РТС")));
			streams.Add(RtsIndexLogStream = new PlazaStream(new PlazaTable(PlazaTableId.RtsIndexLog, "История значений индексов РТС")));
			streams.Add(SessionContentsFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.SessionContentsFuture, "Фьючерсы: cправочник торгуемых инструментов"), SecurityGrops.Future));
			streams.Add(SessionContentsOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.SessionContentsOption, "Опционы: справочник торгуемых инструментов"), SecurityGrops.Option));
			streams.Add(SessionFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.SessionFuture, "Фьючерсы: информация о торговой сессии"), SecurityGrops.Future));
			streams.Add(SysMessagesStream = new PlazaStream(new PlazaTable(PlazaTableId.SysMessages, "Сообщения торговой системы")));
			streams.Add(SessionSettlementOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.SessionSettlementOption, "Опционы: результаты клиринга - волатильность и теоретические цены"), SecurityGrops.Option));
			streams.Add(SessionSettlementFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.SessionSettlementFuture, "Фьючерсы: результаты клиринга - расчетные цены"), SecurityGrops.Future));
			streams.Add(UsdOnlineStream = new PlazaStream(new PlazaTable(PlazaTableId.UsdOnline, "Трансляция курса USD")));
			streams.Add(VcbFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.VcbFuture, "Фьючерсы"), SecurityGrops.Future));
			streams.Add(VcbOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.VcbOption, "Опционы"), SecurityGrops.Option));
			streams.Add(VmFutureStream = new PlazaStream(new PlazaTable(PlazaTableId.VmFuture, "Вариационная маржа по фьючерсам"), SecurityGrops.Future));
			streams.Add(VmOptionStream = new PlazaStream(new PlazaTable(PlazaTableId.VmOption, "Вариационная маржа по опционам"), SecurityGrops.Option));
			streams.Add(VolatilityStream = new PlazaStream(new PlazaTable(PlazaTableId.Volatility, "Волатильность")));
			streams.Add(VolatilitySmileStream = new PlazaStream(new PlazaTable(PlazaTableId.VolatilitySmile, "Таблица с коэффициентами волатильности")));
			streams.Add(ClearingMoneyStream = new PlazaStream(new PlazaTable(PlazaTableId.ClearingMoney, "Клиентские деньги в клиринге")));
			streams.Add(BaseContractsParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.BaseContractsParams, "Параметры базовых контрактов")));
			streams.Add(FuturesParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.FuturesParams, "Параметры фьючерсов"), SecurityGrops.Future));
			streams.Add(VirtualFuturesParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.VirtualFuturesParams, "Параметры виртуальных фьючерсов"), SecurityGrops.Future));
			streams.Add(OptionsParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.OptionsParams, "Параметры опционов"), SecurityGrops.Option));
			streams.Add(BrokerParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.BrokerParams, "Информация о параметрах фирм")));
			streams.Add(ClientParamsStream = new PlazaStream(new PlazaTable(PlazaTableId.ClientParams, "Информация о параметрах клиентов")));
			streams.Add(DilerStream = new PlazaStream(new PlazaTable(PlazaTableId.Diler, "Справочник имен фирм")));
			streams.Add(InvestrStream = new PlazaStream(new PlazaTable(PlazaTableId.Investr, "Справочник клиентов")));

			//streams.Add(FutInstrumentsStream = new PlazaStream(new PlazaTable(PlazaTableId.FutInstruments, "Справочник инструментов")));

			var type = typeof(PlazaColumnRegistry);

			var dict = type.GetMembers<FieldInfo>(BindingFlags.Public | BindingFlags.Static, false)
				.Select(fieldInfo => (PlazaColumns)fieldInfo.GetValue(null))
				.ToDictionary(c => c.TableId, c => c);

			foreach (var stream in streams)
			{
				var meta = dict[stream.Table.Id];
				stream.Table.Columns.AddRange(meta
				                              	.GetType()
				                              	.GetMembers<FieldInfo>(BindingFlags.Public | BindingFlags.Instance)
				                              	.OrderBy(f => GetParentLevel(f.DeclaringType)) // колонки replID, replRev, replAct должны идти первыми
				                              	.Select(f => (PlazaColumn)f.GetValue(meta))
				                              	.Where(c => c.IsMandatory));
			}

			AllStreams = streams.ToArray();

			AggregationFutureStreams = new[] { Aggregation5FutureStream, Aggregation20FutureStream, Aggregation50FutureStream };
			AggregationOptionStreams = new[] { Aggregation5OptionStream, Aggregation20OptionStream, Aggregation50OptionStream };
		}

		private static int GetParentLevel(Type t)
		{
			if (t == typeof(object))
				return 0;
			else
				return GetParentLevel(t.BaseType) + 1;
		}

		/// <summary>
		/// Фьючерсы: стакан глубиной 20 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation20FutureStream;

		/// <summary>
		/// Опционы: стакан глубиной 20 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation20OptionStream;

		/// <summary>
		/// Фьючерсы: стакан глубиной 50 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation50FutureStream;

		/// <summary>
		/// Фьючерсы: все потоки стаканов.
		/// </summary>
		public readonly PlazaStream[] AggregationFutureStreams;

		/// <summary>
		/// Все потоки.
		/// </summary>
		public readonly PlazaStream[] AllStreams;

		/// <summary>
		/// Опционы: стакан глубиной 50 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation50OptionStream;

		/// <summary>
		/// Фьючерсы: стакан глубиной 5 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation5FutureStream;

		/// <summary>
		/// Опционы: стакан глубиной 5 котировок.
		/// </summary>
		public readonly PlazaStream Aggregation5OptionStream;

		/// <summary>
		/// Опционы: все потоки стаканов.
		/// </summary>
		public readonly PlazaStream[] AggregationOptionStreams;

		/// <summary>
		/// Фьючерсы: справочник инструментов облигаций.
		/// </summary>
		public readonly PlazaStream BondIsinFutureStream;

		/// <summary>
		/// Фьючерсы: НКД на даты выплат купонов.
		/// </summary>
		public readonly PlazaStream BondNkdFutureStream;

		/// <summary>
		/// Фьючерсы: размеры выплат номинальной стоимости облигации.
		/// </summary>
		public readonly PlazaStream BondNominalFutureStream;

		/// <summary>
		/// Фьючерсы: справочник параметров облигаций.
		/// </summary>
		public readonly PlazaStream BondRegistryFutureStream;

		/// <summary>
		/// Фьючерсы: общая информация по сессии.
		/// </summary>
		public readonly PlazaStream CommonFutureStream;

		/// <summary>
		/// Опционы: общая информация по сессии.
		/// </summary>
		public readonly PlazaStream CommonOptionStream;

		/// <summary>
		/// Фьючерсы: журнал сделок.
		/// </summary>
		public readonly PlazaStream DealFutureStream;

		/// <summary>
		/// Опционы: журнал сделок.
		/// </summary>
		public readonly PlazaStream DealOptionStream;

		/// <summary>
		/// Фьючерсы: отчет о поставке.
		/// </summary>
		public readonly PlazaStream DeliveryReportFutureStream;

		/// <summary>
		/// Опционы: заявки на экспирацию.
		/// </summary>
		public readonly PlazaStream ExpirationOrdersOptionStream;

		/// <summary>
		/// Фьючерсы: служебная талица серверных часов.
		/// </summary>
		public readonly PlazaStream HeartBeatFutureStream;

		/// <summary>
		/// Опционы: служебная талица серверных часов.
		/// </summary>
		public readonly PlazaStream HeartBeatOptionStream;

		/// <summary>
		/// Фьючерсы: информация о ВМ, рассчитанной по результатам пром. клиринга.
		/// </summary>
		public readonly PlazaStream InterClearingInfoFutureStream;

		/// <summary>
		/// Опционы: информация о ВМ, рассчитанной по результатам пром. клиринга.
		/// </summary>
		public readonly PlazaStream InterClearingInfoOptionStream;

		/// <summary>
		/// Фьючерсы: журнал сделок по связкам.
		/// </summary>
		public readonly PlazaStream MultiLegDealFutureStream;

		/// <summary>
		/// Фьючерсы: журнал заявок по связкам.
		/// </summary>
		public readonly PlazaStream MultiLegOrdersLogFutureStream;

		/// <summary>
		/// Фьючерсы: срез стакана (информация о стаканах).
		/// </summary>
		public readonly PlazaStream OrderBookInfoFutureStream;

		/// <summary>
		/// Опционы: срез стакана (информация о стаканах).
		/// </summary>
		public readonly PlazaStream OrderBookInfoOptionStream;

		/// <summary>
		/// Фьючерсы: срез стакана (логовая таблица заявок).
		/// </summary>
		public readonly PlazaStream OrderBookOrdersFutureStream;

		/// <summary>
		/// Опционы: срез стакана (логовая таблица заявок).
		/// </summary>
		public readonly PlazaStream OrderBookOrdersOptionStream;

		/// <summary>
		/// Фьючерсы: журнал заявок по связкам.
		/// </summary>
		public readonly PlazaStream OrdersLogFutureStream;

		/// <summary>
		/// Опционы: журнал заявок.
		/// </summary>
		public readonly PlazaStream OrdersLogOptionStream;

		/// <summary>
		/// Средства и лимиты клиентов.
		/// </summary>
		public readonly PlazaStream PortfoliosStream;

		/// <summary>
		/// Позиции клиентов.
		/// </summary>
		public readonly PlazaStream PositionsStream;

		/// <summary>
		/// Фьючерсы: отвергнутые в клиринг заявки.
		/// </summary>
		public readonly PlazaStream RejectedOrdersFutureStream;

		/// <summary>
		/// Опционы: отвергнутые в клиринг заявки.
		/// </summary>
		public readonly PlazaStream RejectedOrdersOptionStream;

		/// <summary>
		/// Индексы РТС.
		/// </summary>
		public readonly PlazaStream RtsIndexStream;

		/// <summary>
		/// История значений индексов РТС.
		/// </summary>
		public readonly PlazaStream RtsIndexLogStream;

		/// <summary>
		/// Фьючерсы: cправочник торгуемых инструментов.
		/// </summary>
		public readonly PlazaStream SessionContentsFutureStream;

		/// <summary>
		/// Опционы: справочник торгуемых инструментов.
		/// </summary>
		public readonly PlazaStream SessionContentsOptionStream;

		/// <summary>
		/// Фьючерсы: информация о торговой сессии.
		/// </summary>
		public readonly PlazaStream SessionFutureStream;

		/// <summary>
		/// Cообщения торговой системы.
		/// </summary>
		public readonly PlazaStream SysMessagesStream;

		/// <summary>
		/// Опционы: результаты клиринга - волатильность и теоретические цены.
		/// </summary>
		public readonly PlazaStream SessionSettlementOptionStream;

		/// <summary>
		/// Фьючерсы: результаты клиринга - расчетные цены.
		/// </summary>
		public readonly PlazaStream SessionSettlementFutureStream;

		/// <summary>
		/// Трансляция курса USD.
		/// </summary>
		public readonly PlazaStream UsdOnlineStream;

		/// <summary>
		/// Фьючерсы.
		/// </summary>
		public readonly PlazaStream VcbFutureStream;

		/// <summary>
		/// Опционы.
		/// </summary>
		public readonly PlazaStream VcbOptionStream;

		/// <summary>
		/// Вариационная маржа по фьючерсам.
		/// </summary>
		public readonly PlazaStream VmFutureStream;

		/// <summary>
		/// Вариационная маржа по опционам.
		/// </summary>
		public readonly PlazaStream VmOptionStream;

		/// <summary>
		/// Волатильность.
		/// </summary>
		public readonly PlazaStream VolatilityStream;

		/// <summary>
		/// Таблица с коэффициентами волатильности.
		/// </summary>
		public readonly PlazaStream VolatilitySmileStream;

		/// <summary>
		/// Клиентские деньги в клиринге.
		/// </summary>
		public readonly PlazaStream ClearingMoneyStream;

		/// <summary>
		/// Параметры базовых контрактов.
		/// </summary>
		public readonly PlazaStream BaseContractsParamsStream;

		/// <summary>
		/// Параметры фьючерсов.
		/// </summary>
		public readonly PlazaStream FuturesParamsStream;

		/// <summary>
		/// Параметры виртуальных фьючерсов.
		/// </summary>
		public readonly PlazaStream VirtualFuturesParamsStream;

		/// <summary>
		/// Параметры опционов.
		/// </summary>
		public readonly PlazaStream OptionsParamsStream;

		/// <summary>
		/// Информация о параметрах фирм.
		/// </summary>
		public readonly PlazaStream BrokerParamsStream;

		/// <summary>
		/// Информация о параметрах клиентов.
		/// </summary>
		public readonly PlazaStream ClientParamsStream;

		/// <summary>
		/// Справочник имен фирм.
		/// </summary>
		public readonly PlazaStream DilerStream;

		/// <summary>
		/// Справочник клиентов.
		/// </summary>
		public readonly PlazaStream InvestrStream;

		/// <summary>
		/// Обязательства ММ по фьючерсам.
		/// </summary>
		public readonly PlazaStream MMFutureStream;

		/// <summary>
		/// Обязательства ММ по опционам.
		/// </summary>
		public readonly PlazaStream MMOptionStream;
	}
}