namespace StockSharp.Plaza.Wrappers
{
	using System;

	/// <summary>
	///     .
	/// </summary>
	static class WrapperHelper
	{
		private static readonly bool _isX86 = !Environment.Is64BitProcess;

		/// <summary>
		///      .
		/// </summary>
		/// <returns></returns>
		public static ITableSetWrapper CreateTableSet()
		{
			return _isX86 ? (ITableSetWrapper)new TableSetWrapper32() : new TableSetWrapper64();
		}

		/// <summary>
		///      .
		/// </summary>
		/// <returns></returns>
		public static IStreamWrapper CreateStream()
		{
			return _isX86 ? (IStreamWrapper)new StreamWrapper32() : new StreamWrapper64();
		}

		/// <summary>
		///   .
		/// </summary>
		/// <returns></returns>
		public static IConnectionWrapper CreateConnection()
		{
			return _isX86 ? (IConnectionWrapper)new ConnectionWrapper32() : new ConnectionWrapper64();
		}

		/// <summary>
		///   -    .
		/// </summary>
		/// <returns></returns>
		public static IMessageFactoryWrapper CreateMessageFactory()
		{
			return _isX86 ? (IMessageFactoryWrapper)new MessageFactoryWrapper32() : new MessageFactoryWrapper64();
		}
	}
}